package org.vraptor.interceptor;

import org.vraptor.Interceptor;
import org.vraptor.LogicRequest;
import org.vraptor.component.ComponentInstantiationException;
import org.vraptor.introspector.Introspector;
import org.vraptor.reflection.GettingException;
import org.vraptor.reflection.SettingException;

/**
 * Deals with injecting and outjecting to and from interceptors
 * 
 * @author Guilherme Silveira
 * @author Paulo Silveira
 */
public class InterceptorDealer {

	private Introspector introspector;

	public InterceptorDealer(Introspector introspector) {
		this.introspector = introspector;
	}

	public void outject(Interceptor interceptor, LogicRequest context) throws GettingException {
		introspector.outject(InterceptorType.getType(interceptor).getOutAnnotations(), interceptor, context);
	}

	public void inject(Interceptor interceptor, LogicRequest context) throws ComponentInstantiationException,
			SettingException {
		this.introspector.inject(InterceptorType.getType(interceptor).getInAnnotations(), interceptor, context);
	}

}
