package org.vraptor.interceptor;

import org.vraptor.Interceptor;
import org.vraptor.LogicException;
import org.vraptor.LogicFlow;
import org.vraptor.component.ComponentType;
import org.vraptor.introspector.Introspector;
import org.vraptor.reflection.GettingException;
import org.vraptor.view.ViewException;

/**
 * Outjects.
 * 
 * @author Guilherme Silveira
 */
public class OutjectionInterceptor implements Interceptor {
	
	private ComponentType type;
	
	private Introspector introspector;

	public OutjectionInterceptor(Introspector introspector, ComponentType componentClass) {
		this.introspector = introspector;
		this.type = componentClass;
	}

	public void intercept(LogicFlow flow) throws LogicException, ViewException {

		Object component = flow.getLogicRequest().getLogicContext().getComponent();

		try {
			introspector.outject(type.getOutAnnotations(), component, flow.getLogicRequest());
		} catch (GettingException e) {
			throw new LogicException(e.getMessage(), e);
		}

		flow.execute();

	}

}
