package org.vraptor.interceptor;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.vraptor.Interceptor;
import org.vraptor.LogicException;
import org.vraptor.LogicFlow;
import org.vraptor.reflection.JavaMethod;
import org.vraptor.scope.DefaultLogicRequest;
import org.vraptor.scope.LogicContext;
import org.vraptor.scope.RequestContext;
import org.vraptor.view.ViewException;

public class RegisterAttributesInteceptor implements Interceptor {

	public static final String LOGIC_METHOD_KEY = "org.vraptor.logic_method";

	private JavaMethod method;

	public RegisterAttributesInteceptor(JavaMethod method) {
		this.method = method;
	}

	public void intercept(LogicFlow flow) throws LogicException, ViewException {
		DefaultLogicRequest req = (DefaultLogicRequest) flow.getLogicRequest();
		LogicContext logic = flow.getLogicRequest().getLogicContext();
		logic.setAttribute(LOGIC_METHOD_KEY, method.getMethod());
		RequestContext request = flow.getLogicRequest().getRequestContext();
		
		request.setAttribute("request", req.getRequest());
		request.setAttribute("httpServletRequest", req.getRequest());
		
		request.setAttribute("response", req.getResponse());
		request.setAttribute("httpServletResponse", req.getResponse());
		
		request.setAttribute("application", req.getApplicationContext());
		request.setAttribute("servletContext", req.getApplicationContext());

		request.setAttribute("session", req.getRequest().getSession());
		request.setAttribute("httpSession", req.getRequest().getSession());
		
		// TODO: HttpSession with big H? sure?
		logic.setAttribute(HttpSession.class.getName(), req.getRequest().getSession());
		logic.setAttribute(HttpServletRequest.class.getName(), req.getRequest());
		logic.setAttribute(HttpServletResponse.class.getName(), req.getResponse());
		logic.setAttribute(ServletContext.class.getName(), req.getRequest().getSession().getServletContext());
		flow.execute();
	}
}
